package se.softstuff.nb.nbtranslate.ide.create;

import org.openide.util.editable.BrandedLocaleBuilder;
import java.util.*;
import java.util.concurrent.ExecutionException;
import javax.swing.*;
import org.netbeans.api.java.project.JavaProjectConstants;
import org.netbeans.api.progress.ProgressHandle;
import org.netbeans.api.progress.ProgressHandleFactory;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ProjectUtils;
import org.netbeans.api.project.SourceGroup;
import org.netbeans.api.project.Sources;
import org.openide.filesystems.FileObject;
import org.openide.util.Exceptions;
import org.openide.util.NbBundle;
import org.openide.util.editable.BrandedLocale;
import se.softstuff.nb.nbtranslate.swing.ColumnRenderer;
import se.softstuff.nb.nbtranslate.swing.DynamicTableModel;

public final class CreateProjectVisualPanel2 extends JPanel {

    private DynamicTableModel<RowModel> tableModel;

    /**
     * Creates new form CreateProjectVisualPanel2
     */
    public CreateProjectVisualPanel2() {
        tableModel = new DynamicTableModel<RowModel>();
        tableModel.addColumn(new LanguageRendrer(), new UseRendrer());
        initComponents();
    }


    public List<BrandedLocale> getLocales() {

        List<BrandedLocale> useThis = new ArrayList<BrandedLocale>();
        for(RowModel row : tableModel.getRows()){
            if(row.use){
                useThis.add(row.language);
            }
        }
        return useThis;
    }


    @Override
    public String getName() {
        return NbBundle.getMessage(getClass(), "CreateProjectVisualPanel2.bulletin"); //NOI18N
    }


    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();

        setName("Form"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTable1.setModel(tableModel);
        jTable1.setName("jTable1"); // NOI18N
        jScrollPane1.setViewportView(jTable1);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, "<html>All languages will automatically be included in the project disregarding your choise  above - they will be visible during translation. <br><br> Optional limitation above will effect later export to OmegaT.  You should at least select the destination language together with an original language that will be used in OmegaT."); // NOI18N
        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jLabel1.setName("jLabel1"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 390, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 229, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables

    void init(Set<Project> selectedProjects, List<BrandedLocale> selectedLanguages) {
        new FindAllKnownLocales(selectedProjects, selectedLanguages).execute();
    }


    private class FindAllKnownLocales extends SwingWorker<Set<BrandedLocale>, Integer> {

        public static final String PROPERTIES = "properties"; //NOI18N
        private static final String BUNDLE = "bundle"; //NOI18N
        private Collection<? extends Project> projectToLookThrue;
        private ProgressHandle progress;
        private List<BrandedLocale> selectedLanguages;

        public FindAllKnownLocales(Collection<? extends Project> projectToLookThrue, List<BrandedLocale> selectedLanguages) {
            this.projectToLookThrue = projectToLookThrue;
            this.selectedLanguages = selectedLanguages;
            progress = ProgressHandleFactory.createHandle(NbBundle.getMessage(CreateProjectVisualPanel2.class, "CreateProjectVisualPanel2.progress.title")); //NOI18N
        }

        @Override
        protected Set<BrandedLocale> doInBackground() throws Exception {
            progress.start(projectToLookThrue.size());
            int projectNr = 1;
            Set<BrandedLocale> locales = new HashSet<BrandedLocale>();
            for (Project project : projectToLookThrue) {
                progress.progress(projectNr++);
                Sources sources = ProjectUtils.getSources(project);
                if (sources == null) {
                    continue;
                }
                SourceGroup[] sourceGroups = sources.getSourceGroups(JavaProjectConstants.SOURCES_TYPE_RESOURCES);

                for (SourceGroup resources : sourceGroups) {
                    Enumeration<? extends FileObject> children = resources.getRootFolder().getData(true);
                    while (children.hasMoreElements()) {
                        FileObject file = children.nextElement();
                        if (file.getExt().equalsIgnoreCase(PROPERTIES) && file.getName().toLowerCase().startsWith(BUNDLE)) {
                            BrandedLocale locale = BrandedLocaleBuilder.parse(file.getName());
                            if (locale != null) {
                                locales.add(locale);
                            }
                        }
                    }

                }
            }
            return locales;
        }

        @Override
        protected void done() {
            progress.finish();
            try {
                List<RowModel> rows = new ArrayList<RowModel>();
                for(BrandedLocale locale : get() ){
                    Boolean selected = selectedLanguages==null ? Boolean.TRUE : selectedLanguages.contains(locale);
                    rows.add(new RowModel(locale, selected));
                }
                tableModel.setRows(rows);

            } catch (InterruptedException ex) {
                Exceptions.printStackTrace(ex);
            } catch (ExecutionException ex) {
                Exceptions.printStackTrace(ex);
            }

        }
    }

    private class RowModel{
        BrandedLocale language;
        Boolean use;
        RowModel(BrandedLocale language, Boolean use){
            this.language = language;
            this.use = use;
        }
    }

    private class LanguageRendrer extends ColumnRenderer<RowModel, String>{

        @Override
        public String headerText() {
            return NbBundle.getMessage(CreateProjectVisualPanel2.class, "LanguageRendrer.header.label");
        }

        @Override
        public String render(RowModel row) {
            return row.language.getBrandedDisplayName(NbBundle.getMessage(CreateProjectVisualPanel2.class, "LanguageRendrer.default"));
        }

    }

    private class UseRendrer extends ColumnRenderer<RowModel, Boolean>{

        @Override
        public String headerText() {
            return NbBundle.getMessage(CreateProjectVisualPanel2.class, "UseRendrer.header.label");
        }

        @Override
        public Boolean render(RowModel row) {
            return row.use;
        }

        @Override
        public boolean isCellEditable(RowModel row) {
            return true;
        }

        @Override
        public void setValueAt(RowModel row, Boolean aValue) {
            row.use = aValue;
        }



    }
}
